- Main Page
- Namespaces
- Classes
- Files
- Directories
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Exponent::GUI::Windowing::IWindow Interface Reference

Inheritance diagram for Exponent::GUI::Windowing::IWindow:

List of all members.

## Detailed Description

Interface to a window. All window classes must implement this interface.

Date:
  18/03/2005

Author:
  Paul Chana

Version:
  1.0.0 Initial version

Note:
  All contents of this source code are copyright 2005 Exp Digital Uk.
  This source file is covered by the licence conditions of the Infinity API. You should have recieved a copy
  with the source code. If you didnt, please refer to http://www.expdigital.co.uk All content is the Intellectual property of Exp Digital Uk.
  Certain sections of this code may come from other sources. They are credited where applicable.
  If you have comments, suggestions or bug reports please visit http://support.expdigital.co.uk

Id
  IWindow.hpp,v 1.6 2007/02/11 02:16:22 paul Exp

Definition at line 71 of file IWindow.hpp.

## Public Member Functions

- virtual void addTimedObject (ITimedObject *timedObject)=0
- virtual void clearTimedObjects ()=0
- virtual void closeWindow ()=0
- virtual void destroyWindow ()=0
- virtual void disableWindow ()=0
- virtual void draw (CGraphics &graphics)=0
- virtual void enableWindow ()=0
- virtual IControlRoot * getControlRoot () const=0
- virtual CMouse * getMouse ()=0
- virtual SWindowHandle * getMutableWindowHandle () const=0
- virtual IWindow * getParentWindow () const=0
- virtual CWindowAttributes * getWindowAttributes () const=0
- virtual const SWindowHandle * getWindowHandle () const=0
- virtual const CPoint & getWindowPosition () const=0
- virtual const CRect & getWindowPositionAndSize () const=0
- virtual const CDimension & getWindowSize () const=0
- virtual void handleTimerEvent (const long id)=0
- virtual void initialiseWindow (CWindowAttributes *windowAttributes, const bool showWindow)=0
- virtual bool isDropFileEnabled () const=0
- virtual bool isKeyboardEnabled () const=0
- virtual bool isMouseEnabled () const=0
- IWindow ()
- virtual void openWindow ()=0
- virtual void redrawWindow ()=0
- virtual void redrawWindow (const CRect &area)=0
- virtual void registerChildWindow (IWindow *child)=0
- virtual void registerDropFileListener (IDropFileListener *listener)=0
- virtual void registerFocusListener (IFocusListener *listener)=0
- virtual void registerKeyboardListener (IKeyboardListener *listener)=0
- virtual void registerMouseListener (IMouseListener *listener)=0
- virtual void registerWindowChangeListener (IWindowChangeListener *listener)=0
- virtual void removeTimedObject (ITimedObject *timedObject)=0
- virtual void setParentWindow (IWindow *parent)=0
- virtual void setWindowAlpha (const double alpha)=0
- virtual void setWindowPosition (const CPoint &position)=0
- virtual void setWindowPositionAndSize (const CRect &positionAndSize)=0
- virtual void setWindowSize (const CDimension &dimension)=0
- virtual void startTimer (const long id, const long timeInMilliseconds)=0
- virtual void stopTimer (const long id)=0
- virtual void uninitialiseWindow ()=0
- virtual void unregisterAllChildWindows ()=0
- virtual void unregisterChldWindow (IWindow *child)=0
- virtual void updateWindow ()=0
- virtual ~IWindow ()

## Constructor & Destructor Documentation

Exponent::GUI::Windowing::IWindow::IWindow | ( |  | ) | `[inline]`

Construction

Definition at line 83 of file IWindow.hpp.

virtual Exponent::GUI::Windowing::IWindow::~IWindow | ( |  | ) | `[inline, virtual]`

Destruction

Definition at line 88 of file IWindow.hpp.

## Member Function Documentation

virtual void Exponent::GUI::Windowing::IWindow::addTimedObject | ( | ITimedObject * | timedObject | ) | `[pure virtual]`

Add a new timed object

Parameters:

  | timedObject | The object to add to the timer collection

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::clearTimedObjects | ( |  | ) | `[pure virtual]`

Clear the timed bojects

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::closeWindow | ( |  | ) | `[pure virtual]`

Close the widnow

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::destroyWindow | ( |  | ) | `[pure virtual]`

Destroy the widnow

Note:
  clears internal buffers, and uninitialises the window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::disableWindow | ( |  | ) | `[pure virtual]`

Disable the window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::draw | ( | CGraphics & | graphics | ) | `[pure virtual]`

Draw the window images...

Parameters:

  | graphics | The graphics handle to use

virtual void Exponent::GUI::Windowing::IWindow::enableWindow | ( |  | ) | `[pure virtual]`

Enable the window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual IControlRoot* Exponent::GUI::Windowing::IWindow::getControlRoot | ( |  | ) | const`[pure virtual]`

Get the control root

Return values:

  | IControlRoot* | The control root of this window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual CMouse* Exponent::GUI::Windowing::IWindow::getMouse | ( |  | ) | `[pure virtual]`

Get the mouse

Return values:

  | CMouse* | The mouse for this window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual SWindowHandle* Exponent::GUI::Windowing::IWindow::getMutableWindowHandle | ( |  | ) | const`[pure virtual]`

Get the widow handle

Return values:

  | SWindowHandle* | The handle of this window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual IWindow* Exponent::GUI::Windowing::IWindow::getParentWindow | ( |  | ) | const`[pure virtual]`

Get hte parent window

Return values:

  | IWindow* | The parent window, may be NULL

Note:
  For future use

Implemented in Exponent::GUI::Windowing::CWindow.

virtual CWindowAttributes* Exponent::GUI::Windowing::IWindow::getWindowAttributes | ( |  | ) | const`[pure virtual]`

Get the widow attributes

Return values:

  | CWindowAttributes* | The attributes of this window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual const SWindowHandle* Exponent::GUI::Windowing::IWindow::getWindowHandle | ( |  | ) | const`[pure virtual]`

Get the widow handle

Return values:

  | const | SWindowHandle* The handle of this window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual const CPoint& Exponent::GUI::Windowing::IWindow::getWindowPosition | ( |  | ) | const`[pure virtual]`

Get the postion relative to the parent

Return values:

  | const | CPoint& The window position relative to the parent, usually the desktop

Implemented in Exponent::GUI::Windowing::CWindow.

virtual const CRect& Exponent::GUI::Windowing::IWindow::getWindowPositionAndSize | ( |  | ) | const`[pure virtual]`

Get the size and position

Return values:

  | const | CRect& The size and position of the window

See also:
  getWindowSize

  getWindowPosition

Implemented in Exponent::GUI::Windowing::CWindow.

virtual const CDimension& Exponent::GUI::Windowing::IWindow::getWindowSize | ( |  | ) | const`[pure virtual]`

Get the size of the window

Return values:

  | const | CDimension& The dimension of the window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::handleTimerEvent | ( | const long | id | ) | `[pure virtual]`

Handle a timer event happening - Intended for internal use

Parameters:

  | id | The id of the timer that has fired an event

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::initialiseWindow | ( | CWindowAttributes * | windowAttributes,
|  | const bool | showWindow |
| ) |  |  | `[pure virtual]`

Initilalise the window

Parameters:

  | windowAttributes | The window attributes. (copy should be made, do not store this pointer - it may be deleted...)
  | showWindow | Should the window be shown immediately

Implemented in Exponent::GUI::Windowing::CWindow.

virtual bool Exponent::GUI::Windowing::IWindow::isDropFileEnabled | ( |  | ) | const`[pure virtual]`

Can the window handle dropped files??

Return values:

  | bool | True if window can handle dropped files, false otherwise

Implemented in Exponent::GUI::Windowing::CWindow.

virtual bool Exponent::GUI::Windowing::IWindow::isKeyboardEnabled | ( |  | ) | const`[pure virtual]`

Can the window handle dropped files??

Return values:

  | bool | True if window can handle keyboard events, false otherwise

Implemented in Exponent::GUI::Windowing::CWindow.

virtual bool Exponent::GUI::Windowing::IWindow::isMouseEnabled | ( |  | ) | const`[pure virtual]`

Can the window handle dropped files??

Return values:

  | bool | True if window can handle mouse events, false otherwise

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::openWindow | ( |  | ) | `[pure virtual]`

Open the window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::redrawWindow | ( |  | ) | `[pure virtual]`

Set the whole window dirty - generally use sparingly!!

Implemented in Exponent::GUI::Windowing::CWindow, and Exponent::Vst::CVstWindow.

virtual void Exponent::GUI::Windowing::IWindow::redrawWindow | ( | const CRect & | area | ) | `[pure virtual]`

Set an area of the window dirty

Parameters:

  | area | The area of the window relative to its top left to draw

virtual void Exponent::GUI::Windowing::IWindow::registerChildWindow | ( | IWindow * | child | ) | `[pure virtual]`

Register a child window

Parameters:

  | child | The child window

Note:
  For future use

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::registerDropFileListener | ( | IDropFileListener * | listener | ) | `[pure virtual]`

Register a drop file listener

Parameters:

  | listener | The listener for drop file information

virtual void Exponent::GUI::Windowing::IWindow::registerFocusListener | ( | IFocusListener * | listener | ) | `[pure virtual]`

Register a focus listener

Parameters:

  | listener | The listener for window focus information

virtual void Exponent::GUI::Windowing::IWindow::registerKeyboardListener | ( | IKeyboardListener * | listener | ) | `[pure virtual]`

Register keyboard listener

Parameters:

  | listener | The listener for keyboard information

virtual void Exponent::GUI::Windowing::IWindow::registerMouseListener | ( | IMouseListener * | listener | ) | `[pure virtual]`

Register a mouse listener

Parameters:

  | listener | The listener for mouse information

virtual void Exponent::GUI::Windowing::IWindow::registerWindowChangeListener | ( | IWindowChangeListener * | listener | ) | `[pure virtual]`

Register a window change listener

Parameters:

  | listener | The listener for window change information

virtual void Exponent::GUI::Windowing::IWindow::removeTimedObject | ( | ITimedObject * | timedObject | ) | `[pure virtual]`

Remove a timed objects

Parameters:

  | timedObject | The object to remove from timing

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::setParentWindow | ( | IWindow * | parent | ) | `[pure virtual]`

Set the parent window of this window

Parameters:

  | parent | The parent window

Note:
  For future use

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::setWindowAlpha | ( | const double | alpha | ) | `[pure virtual]`

Set the window alpha value

Parameters:

  | alpha | The alpha level 0 - 1

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::setWindowPosition | ( | const CPoint & | position | ) | `[pure virtual]`

Set the position of the window relative to its parent

Parameters:

  | position | The position relative to the parent, usually the desktop

virtual void Exponent::GUI::Windowing::IWindow::setWindowPositionAndSize | ( | const CRect & | positionAndSize | ) | `[pure virtual]`

Set the size and position

Parameters:

  | positionAndSize | The new position and size of the window

virtual void Exponent::GUI::Windowing::IWindow::setWindowSize | ( | const CDimension & | dimension | ) | `[pure virtual]`

Set the size of the widnwo

Parameters:

  | dimension | The dimension of the window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::startTimer | ( | const long | id,
|  | const long | timeInMilliseconds |
| ) |  |  | `[pure virtual]`

Start a timer

Parameters:

  | id | The unique id of the timer object to start
  | timeInMilliseconds | The time in milliseconds between updates

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::stopTimer | ( | const long | id | ) | `[pure virtual]`

Stop a timer

Parameters:

  | id | The unique id of the timer

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::uninitialiseWindow | ( |  | ) | `[pure virtual]`

Uninitialise the window

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::unregisterAllChildWindows | ( |  | ) | `[pure virtual]`

Unregister all child windows

Note:
  For future use

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::unregisterChldWindow | ( | IWindow * | child | ) | `[pure virtual]`

Unregister a specific child window

Parameters:

  | child | The child window to unregister

Note:
  For future use

Implemented in Exponent::GUI::Windowing::CWindow.

virtual void Exponent::GUI::Windowing::IWindow::updateWindow | ( |  | ) | `[pure virtual]`

Update the window redraws entire window

Implemented in Exponent::GUI::Windowing::CWindow.